<?php
// $Id: og_teampage_47.inc,v 1.1.2.3 2007/03/02 07:57:00 martinsfromb Exp $
function og_teampage_view(&$node, $teaser = FALSE, $page = FALSE) {	
		$node = node_prepare($node, $teaser);
		$node->teaser = theme('og_teampage_teaser', $node);
		$node->body = theme('og_teampage_body', $node);
		if ($teaser)
		{
			$node->og_description = $node->teaser;
		}
	$node->readmore = 0;
}


function og_teampage_link($type, $node = NULL, $teaser = FALSE) {
  if ($node->type == 'teampage')
	{
  	$links = array(); 
  	if ($teaser){
	  $links[] = l(t('go to teampage'), "node/$node->nid",
			array('title' => t('More about this team on its own teampage.'))); 
	}
 	 return $links;
	}
}	


/**
 * Implementation of hook_help().
 */
function og_teampage_help($section) {
  switch ($section) {
    case 'node/add#teampage':
      return t('A teampage provides a home page for sport teams. There they post articles about their team.');
    case 'admin/modules#description':
      return t('Teampage node for Organic groups');
  }
}

/**
 * Implementation of hook_menu().
 */
function og_teampage_menu($may_cache) {
  $items = array();

  if ($may_cache) {
    $items[] = array('path' => 'node/add/teampage', 'title' => t('teampage'), 'access' => user_access('create teampages'));
  } else
  {

	  if (arg(0) == 'node' && is_numeric(arg(1))) {
		  $node = node_load(arg(1));
		  if ($node->type == 'teampage') {
			$items[] = array('path' => 'node/'. arg(1). '/members', 'title' => t('admin memberships'), 'callback' => 'og_teampage_admin_members_form', 'callback arguments' => array(arg(1)), 'access' => node_access('update', array('nid' => $node->nid, 'status' => 1)), 'type' => MENU_LOCAL_TASK, 'weight' => 7);
		  } else
			  if (og_is_group_type($node->type)) {
				$items[] = array('path' => 'node/'. arg(1). '/members', 'title' => t('configure team table view'), 'callback' => 'og_teampage_admin_members_form', 'callback arguments' => array(arg(1)), 'access' => node_access('update', array('nid' => $node->nid, 'status' => 1)), 'type' => MENU_LOCAL_TASK, 'weight' => 7);
			  };
	  }
  }

  return $items;
}

/**
 * Implementation of hook_node_info().
 * Note that our nodes are type=og instead of type=og_teampage. This is a legacy convenience to when og did n ot support external
 * node types. This will help contributed modules catch up without much pain.
 */
function og_teampage_node_info() {
  return array('teampage' => array('name' => t('teampage'), 'base' => 'og_teampage'));
}

/**
 * Implementation of hook_access().
 */
function og_teampage_access($op, $node) {
  global $user;
  if ($op == 'create') {
    return user_access('create teampages') && $user->uid;
  }
  
  if ($user->uid && $node->uid == $user->uid && ($op == 'update' || $op == 'delete')) {
    return TRUE;
  }
}
/**
 * Implementation of hook_perm().
 */
function og_teampage_perm() {
  return array('create teampages');
}


function og_teampage_filter($op, $delta = 0, $format = -1, $text = '') {
  switch ($op) {
    case 'list':
      return array(0 => t('og group members table'));
	//case 'no cache':
    //  return TRUE;
    case 'description':
      return t('Show the group members of an organic group in a table.');
    case 'process':
		$tag_start = strpos($text, '[teamtable:');
		if ($tag_start === FALSE) {
			return $text;
		} else {
			$tag_end = strpos($text, ']',$tag_start);
			$tag = substr($text, $tag_start, $tag_end - $tag_start + 1);
			$gid = $tag;
			$gid = str_replace('[teamtable:', '', $gid);
			$gid = str_replace(']', '', $gid);
			$text = str_replace($tag, og_teampage_teamtable($gid), $text);
			return $text;
		}
	default:
		return $text;
  }
}


/**
 * Implementation of hook_form().
 */
/*
function og_teampage_form(&$node) {
  $form['title'] = array('#type' => 'textfield', '#title' => t('Name'), '#weight' => -5, '#default_value' => $node->title, '#size' => 60, '#maxlength' => 128, '#required' => true);
  $form['body_filter']['body'] = array('#type' => 'textarea', '#title' => t('Welcome message'), '#default_value' => $node->body, '#rows' => 10, '#required' => FALSE, '#description' => t('This message is shown by default at the top of the group home page.'));
  $form['body_filter']['format'] = filter_form($node->format);
  return $form;
}
*/

function theme_og_teampage_teaser($node)
{
    $output .= '<div class="og_teampage"><div class="teaser">'.$node->teaser.'</div></div>';
	return $output;
}

function sort_members_array($a, $b) {
	if ($a[data]->weight == $b[data]->weight) return 0;
	return ($a[data]->weight > $b[data]->weight) ? 1 : -1;
}



function theme_og_teampage_body($node)
{
	$output = '<div class="og_teampage"><div class="body">'.$node->body;
	$output .= '<h1>'.t('The Team').'</h1>';
	$output .= t('These players are starting in team').' '.$node->title.':<br>';
	$output .= '<br>';
   	$output .= og_teampage_teamtable($node->nid);
	$output .= '</div></div>';
	return $output;
}

function og_teampage_settings() {

$form['og_teampage_image_default_path'] = array('#type' => 'textfield', '#title' => t('Default image path'), '#default_value' => variable_get('og_teampage_image_default_path', 'teampage images'), '#description' => t('Subdirectory in the directory "%dir" where pictures will be stored. Do not include trailing slash.', array('%dir' => theme('placeholder', variable_get('file_directory_path', 'files')))));
$form['og_teampage_colcount'] = array('#type' => 'textfield', '#title' => t('Column count in members table'), '#default_value' => variable_get('og_teampage_colcount',5), '#description' => t('How many members should be shown in one row?'));
return $form;
}

function og_teampage_admin_members_form($gid) {
	$node = node_load($gid);
	$access = node_access('update', $node);
	$form['attributes'] = array("#enctype" => "multipart/form-data");
	$form['#attributes']['enctype'] = 'multipart/form-data';
	$sql = og_list_users_sql(0);
	$result = db_query($sql, $gid);
	while ($account = db_fetch_object($result)) {
		$uid = $account->uid;
		$operations = array();
		if (($access) && ($account->uid != $node->uid)) {
          if ($account->is_active) {
            $operations[] = l(t('unsubscribe'), "og/unsubscribe/$gid/$account->uid", array(), "destination=og/users/$gid");
            if ($account->is_admin) {
              $operations[] = l(t('admin: remove'), "og/delete_admin/$gid/$account->uid", array(), 'destination='. $_GET['q']);
            }
            else {
              $operations[] = l(t('admin: create'), "og/create_admin/$gid/$account->uid", array(), 'destination='. $_GET['q']);
            }
          }
          else {
            $operations[] = l(t('approve'), "og/approve/$gid/$account->uid", array(), "destination=og/users/$gid");
            $operations[] = l(t('deny'), "og/deny/$gid/$account->uid", array(), "destination=og/users/$gid");
          }
        }
		$ophtml = '<table>';
		foreach ($operations as $operation) {
			$ophtml .= '<tr><td>'.$operation.'</td></tr>';
		}
		$ophtml .= '</table>';
		
		$form[$uid]['#tree'] = TRUE;
		$form[$uid][op] = array('#type' => 'markup', '#value' => $ophtml);
		$form[$uid][username] = array('#type' => 'markup', '#value' => theme('username', $account));	
		
		$res = db_query("SELECT * FROM {og_teampage_members} WHERE uid='".$uid."' AND gid='".$gid."'");
		if (db_num_rows($res) < 1) {
			$res = db_query("SELECT * FROM {og_teampage_members} WHERE uid='".$uid."' AND gid='0'");
		}
		$data = db_fetch_object($res);
		$form[$uid][weight] = array('#type' => 'weight', '#default_value' => $data->weight, '#title' => t('Weight'), '#delta' => 10);
		$form[$uid][description] = array('#type' => 'textarea', '#default_value' => $data->description, '#title' => t('Description'));		
		$form[$uid][name] = array('#type' => 'textfield', '#default_value' => $data->name, '#size' => 20, '#title' => t('Name in team'));		
		$form[$uid][hidden] = array('#type' => 'checkbox', '#default_value' => $data->hidden, '#title' => t('Hidden at homepage').'?');
		
		$picsource = '/'.drupal_get_path('module', 'og_teampage').'/no-pic.png';
		if ($data->picture1 != '') {
			$picsource =  $data->picture1;
			if (strpos($picsource, 'system/files') === FALSE)
			{
				$picsource = file_create_url($picsource);
			} else $picsource = '/'.$picsource;
		}
		$form[$uid][image] = array('#type' => 'markup', '#value' => '<img src="'.$picsource.'" alt="user-image">');	
		
		$form['image_upload'.$uid] = array('#type' => 'file', '#size' => 10, '#title' => t('Upload new picture'));	
		if ($data->picture1 != '') $form[$uid][image_delete] = array('#type' => 'checkbox', '#title' => t('delete this picture').'?');	
		
		$form[$uid][image_oldpath] = array('#type' => 'value', '#value' => $data->picture1);	
		$form['gid'] = array('#type' => 'value', '#value' => $gid);
		$form['submit'] = array('#type' => 'submit', '#value' => t('Save changes'));
	}
	drupal_set_title(t('Administer memberships of %group', array('%group' => $node->title)));
	return drupal_get_form('og_teampage_admin_members_form', $form);
}

function theme_og_teampage_admin_members_form($form) {
	$rows= array();
	foreach ($form as $name => $element) {
   		if (isset($element['description'])&& is_array($element['description'])) {
      		$rows[] = '<td><strong>'.form_render($element[username]).'</strong></td><td>'.form_render($element[op]).'</td><td>'.form_render($element[name]).'</td><td>'.form_render($element[weight]).'</td><td>'.form_render($element[hidden]).'</td>';
			$rows[] = '<td colspan="4">'.form_render($element[description]).'</td><td><table><tr><td><div style="float:left;">'.form_render($element[image]).'</div> '.form_render($element['image_delete']).'</td></tr><tr><td>'.form_render($form['image_upload'.$name]).'</td></tr></table></td>';
     		unset ($form[$name]);
			unset ($form['image_upload'.$name]);
    	}
  	}
	$gid = $form['gid']['#value'];
	$output .= '<p>'.t('If you want to add some users to the team, click ').l('here',"og/users/$gid/add").'!</p>';
	$output .= '<table>';
	$counter = 0;
	$class = 'even';
	foreach ($rows as $row) {
		$counter++;
		if ($counter == 3) {
			$counter = 1;
			if ($class == 'odd') {
				$class = 'even';
			} else $class = 'odd';
		}
		$output .= '<tr valign="top" class="'.$class.'">'.$row.'</tr>';
		if ($counter == 2) $output .= '<tr valign="top" class="'.$class.'"><td colspan="5">&nbsp;</td></tr>';
	}
	$output .= '</table>';
	$output .= form_render($form);
	return $output;
}

function og_teampage_admin_members_form_submit($form_id, $form_values) {
    $error = FALSE;
	$gid = $form_values['gid'];
	foreach ($form_values as $uid => $value) {
		if (isset($value['description'])&& is_array($value)) {	
			if ($value['image_delete'] == 1)
			{
				$value['image_oldpath'] = '';	
			}
			$newfilename = '';
			$file = file_check_upload('image_upload'.$uid);
				if ($file) {
					if (substr($file->filemime, 0, 6) == 'image/') {
						file_save_upload('image_upload'.$uid, variable_get('og_teampage_image_default_path', 'images') .'/teampage_overview_'.$gid.'_'.$uid.'.'.substr($file->filemime, 6),FILE_EXISTS_REPLACE);
						$newfilename = variable_get('og_teampage_image_default_path', 'images') .'/teampage_overview_'.$gid.'_'.$uid.'.'.substr($file->filemime, 6);
					} else
					{
						$error = TRUE;
						drupal_set_message(t('Uploaded file "'.$file->filename.'" is not a correct image file!'), 'error');
					}
				}
			if ($newfilename == '') $newfilename = $value['image_oldpath'];
			$res = db_query("DELETE FROM {og_teampage_members} WHERE uid='".$uid."' AND gid='".$gid."'");
			$res = db_query("INSERT INTO {og_teampage_members} SET weight='".$value['weight']."', uid='".$uid."', gid='".$gid."', hidden='".$value['hidden']."', name='".$value['name']."', description='".$value['description']."', picture1='".$newfilename."'");
		}
	}
	$res = db_query("DELETE FROM {cache} WHERE 1 = 1");
	if (!$error) drupal_set_message(t('Saved your changes to group ').$gid.'.');
}

?>
